\SXOCT.XPL	MAY-19-98
\Rotating Octahedron 
\Original by Richard Willmore, SX version by Loren Blaney

inc	CODESP;		\Intrinsic routines
code	LINE=31;	\Line-draw intrinsic for X-Y scope

def	Points=12,	\Number of points, or vertices
	R=30000,	\Defines size of octahedron
	SZ=550, SX=550, SY=150, \Determine speed of rotation (larger nos are slower)
	RB=$06;		\Port RB address
int	X, Y, Z,	\Arrays: 3-D coordinates of a point
	Conv,		\Adjustment for converging end points of lines
	ASX;		\Adjustable speed of rotation about X-axis, and scratch



proc	Show;		\Display line segments connecting the points
int	I;
def	Size=720;	\Scale factor to fit image to display (85x85)
begin
for I:= 0, Points-1 do
	Line(Conv, X(I)/Size+128, Y(I)/Size+128);
end;	\Show



proc	Rotate;		\Rotate the points
int	I;
begin
for I:= 0, Points-1 do
	begin
	X(I):= X(I) + Y(I) /SZ;		\Rotate about Z axis at speed SZ
	Y(I):= Y(I) - X(I) /SZ;

	Y(I):= Y(I) + Z(I) /ASX;	\Rotate about X axis at speed ASX
	Z(I):= Z(I) - Y(I) /ASX;

	Z(I):= Z(I) + X(I) /SY;		\Rotate about Y axis at speed SY
	X(I):= X(I) - Z(I) /SY;
	end;
end;	\Rotate



begin	\Main
X:= Reserve(Points*2);
Y:= Reserve(Points*2);
Z:= Reserve(Points*2);

\Set up coordinates defining the starting position of the octahedron:
for ASX:= 0, Points-1 do
	begin
	X(ASX):= 0;
	Y(ASX):= 0;
	Z(ASX):= 0;
	end;
X(0):= +R;
X(3):= -R;
X(6):= +R;
X(9):= -R;
Y(2):= +R;
Y(5):= -R;
Y(8):= -R;
Y(11):= +R;
Z(1):= +R;
Z(4):= +R;
Z(7):= -R;
Z(10):= -R;

Conv:= 5750;
ASX:= SX;
loop	begin
	Show;
	Rotate;

	if (Pin(RB,0)&$01) = 0 then Conv:= Conv + 10;	\Adjust line convergence
	if (Pin(RB,0)&$02) = 0 then Conv:= Conv - 10;

	if (Pin(RB,0)&$04) = 0 then ASX:= ASX + 10;	\Adjust rotation speed
	if ASX > 3000 then ASX:= 3000;
	if (Pin(RB,0)&$08) = 0 then ASX:= ASX - 10;
	if ASX < 10 then ASX:= 10;
	end;
end;	\Main
