;TRIANGLE.ASM	MAY-17-98
;Routine to draw a right triangle using vector graphics on an X-Y scope. 
; This uses the digital-to-analog virtual peripheral.

	PROCESSOR 16C57		;closest PIC chip
	RADIX	DEC
	ERRORLEVEL -302, -305	;bank args are in range; ",F" is the default
	LIST	ST=OFF		;we don't need no stinking symbol table

	INCLUDE	"SXDEFS.INC"	;macro definitions for new instructions, etc.

DEVICE	EQU	PINS28+OSCHS+PAGES4+BANKS8+TURBO+SYNC+STACKX+OPTIONX

		ORG	08h
RegA	RES	2		;16-bit scratch "register"

PORTBUF	RES	1		;RC port buffer
PWM0	RES	1		;digital value to output on A0 as analog voltage
PWM0ACC	RES	1		;accumulator for A0
PWM1	RES	1		;digital value to output on A1 as analog voltage
PWM1ACC	RES	1		;accumulator for A1

	ORG	0
;-------------------------------------------------------------------------------
; Interrupt routine - virtual analog to digital peripherals
;
	CLRF	PORTBUF
	MOVF	PWM0,W
	ADDWF	PWM0ACC
	BTFSC	STATUS,C
	 BSF	PORTBUF,0

	MOVF	PWM1,W
	ADDWF	PWM1ACC
	BTFSC	STATUS,C
	 BSF	PORTBUF,2

	MOVF	PORTBUF,W
	MOVWF	RC

	MOVLW	-100
	RETIW

;-------------------------------------------------------------------------------
;
;NOTE THAT INTERRUPTS INCREASE THE TIMING
;CONSTANT TO DELAY FOR 693US AT 50MHZ
;TIME	EQU	693*50/5
;TIME	EQU	658*50/5
TIME	EQU	625*50/5

DELAY	MOVLW	low TIME
	MOVWF	RegA
	MOVLW	high TIME
	MOVWF	RegA+1

DLY50	NOP			;kill 5 cycles per loop (in turbo mode)
	DECFSZ	RegA		;loop on low byte
	 GOTO	DLY50
	DECFSZ	RegA+1		;loop on high byte
	 GOTO	DLY50
	RETP

;-------------------------------------------------------------------------------
;
RESET	CLRF	RC
	MOVLW	0FAh
	TRIS	RC

	;NECESSARY???
	MODE	0Dh		;set CMOS input levels
	MOVLW	0
	TRIS	RC
	MODE	0Fh

	MOVLW	9Fh		;enable RTCC interrupts, 1:1 div ratio
	OPTION

;DRAW A RIGHT TRIANGLE:
;apply voltages:
LOOP	MOVLW	0		;PWM0:= 0
	MOVWF	PWM0
	MOVLW	42		;PWM1:= 42
	MOVWF	PWM1
	CALL	DELAY

	MOVLW	255
	MOVWF	PWM0
	MOVLW	85
	MOVWF	PWM1
	CALL	DELAY

	MOVLW	170
	MOVWF	PWM0
	MOVLW	170
	MOVWF	PWM1
	CALL	DELAY
	GOTO	LOOP


	ORG	7FFh
	GOTO	RESET
	END
